//ICC-AVR application builder : 11.03.2009 10:09:26
// Target : M16
// Crystal: 16.0000Mhz

#include <iom16v.h>
#include <macros.h>
#include "math.h"
#include "DFT_AVR.h"

unsigned char value;

unsigned char countVD = 128;
unsigned char count = 0;
unsigned char N;
volatile unsigned char f_adc = 0;

unsigned char buffer[512];
unsigned char *buffer_ukaz;

unsigned short countBuf = 0;
unsigned short countFIR = 512;

char ukaz=0;				   
unsigned int countStr = 30;
unsigned int countStrTek = 0;
char portb1 = 0;

unsigned char f_fir = 0;
unsigned char firN = 0;
unsigned char Uadc;
unsigned char Uadc1;
unsigned char Uadc3;
unsigned char Uadc2;
unsigned char Uadc4;
unsigned char Uadc5;
unsigned char Uadc6;
unsigned char Uadc7;
unsigned char Uadc8;
unsigned char Uadc9;
unsigned char Uadc10;
unsigned char Uadc11;
unsigned char Uadc12;
unsigned char smech = 0;

void VD_select(void);

//call this routine to initialize all peripherals
void init_devices(void)
{ 
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 
 buffer_ukaz = buffer;
 //  
 DDRA  = 0xFE;
 PORTA = 0x00; 
 DDRB  = 0xFF;
 PORTB = 0x1C; 
 PORTC = 0x00; //m103 output only
 DDRC  = 0xFF;
 DDRD  = 0xFF;
 PORTD = 0x00;//0x40; 
 //   : 52 uS 19.2 
 ADCSR = 0x00; //disable adc
 ADMUX = 0x00; //select adc input 0 //    
 ACSR  = 0x80;
 ADCSR = 0xEE; //0xCD; 

 MCUCR = 0x12; 
 GICR  = 0x00;
 TIMSK = 0x00; //timer interrupt sources
 SEI(); //re-enable interrupts
 //all peripherals are now initialized 
 asm("sleep"); //    ,     
}

//
void main(void)
{
 init_devices();
 //insert your functional code here... 
 while(1)
 {
    while(f_adc==0);   
    //----------------- 
	Uadc1 = DFT_1(buffer_ukaz);	
	Uadc2 = DFT_2(buffer_ukaz);
	Uadc3 = DFT_3(buffer_ukaz);
	Uadc4 = DFT_4(buffer_ukaz); 
	Uadc5 = DFT_5(buffer_ukaz); 	   		
	Uadc6 = DFT_6(buffer_ukaz);  
	Uadc7 = DFT_7(buffer_ukaz);	  
	Uadc8 = DFT_8(buffer_ukaz);  //  1,2 	
	Uadc9 = DFT_9(buffer_ukaz);  
	Uadc10 = DFT_10(buffer_ukaz);	
	Uadc11 = DFT_11(buffer_ukaz);		  		
    Uadc12 = DFT_12(buffer_ukaz);	  
		
	f_adc=0;	
	MCUCR = 0x12;    //        
    asm("sleep");	 //           
  } 
}


//     19.2kHz
#pragma interrupt_handler adc_isr:15
void adc_isr(void)
{
 //conversion complete, read value (int) using...
 value  = ADCL>>2;            //Read 8 low bits first (important)
 value |= ADCH<<6;  
 count++;
 if(count==countVD)           // 
 { 
    count = 0;
    VD_select(); 
 }	
 if(f_adc == 0)               //      
 {
    buffer[countBuf] = value;
    countBuf++; 
  
    if(countBuf==countFIR)    //     
    {
       countBuf=0;
	   f_adc=1;	      	 	  //        
    } 
    else
    { 
       MCUCR = 0x12;          //    ,       
       asm("sleep");
    }
 }   
}

//---------------------    
void adc_interrupt(void)
{
   if(ADCSR&0x10)
   {
      count++;
      if(count==countVD)           // 
      { 
         count = 0;
		 VD_select(); 
      }	
   }   
}

//---------------------  
void VD_select(void)
{
    N++;
    switch(N)
	{
	   case 1:
	      //PORTB = 0x1C;
		  PORTD = Uadc1;//privet[ukaz];
		  PORTC = Uadc2;//privet[ukaz+1];
		  PORTA = Uadc3&0xFE;//privet[ukaz+2]&0xFE;
		  portb1 = Uadc3&0x01;//privet[ukaz+2]&0x01;
		  PORTB = portb1|0x1C;			  
		  break;	      
	   case 2:
	      //PORTB = 0x1A;
		  PORTD = Uadc4;//privet[ukaz+3];
		  PORTC = Uadc5;//privet[ukaz+4];
		  PORTA = Uadc6&0xFE;//privet[ukaz+5]&0xFE;
		  portb1 = Uadc6&0x01;//privet[ukaz+5]&0x01;
		  PORTB = portb1|0x1A;	
		  break;
	   case 3:
	      //PORTB = 0x16;
		  PORTD = Uadc7;//privet[ukaz+6];
		  PORTC = Uadc8;//privet[ukaz+7];
		  PORTA = Uadc9&0xFE;//privet[ukaz+8]&0xFE;
		  portb1 = Uadc9&0x01;//privet[ukaz+8]&0x01;
		  PORTB = portb1|0x16;		  
		  break;	   
	   case 4:	      
		  PORTD = Uadc10;//privet[ukaz+9];
		  PORTC = Uadc11;//privet[ukaz+10];
		  PORTA = Uadc12&0xFE;//privet[ukaz+11]&0xFE;
		  portb1 = Uadc12&0x01;//privet[ukaz+11]&0x01;
		  PORTB = portb1|0x0E;
		  N = 0;		  
		  break;	    	  	   
	}		   
}




