//ICC-AVR application builder : 11.03.2009 10:09:26
// Target : M16
// Crystal: 16.0000Mhz

#include <iom16v.h>
#include <macros.h>
#include "math.h"

unsigned char value;

unsigned char countVD = 128;
unsigned char count = 0;
unsigned char N;
volatile unsigned char f_adc = 0;

unsigned char buffer[512];
unsigned short countBuf = 0;
unsigned short countFIR = 512;

const char privet[49] = {0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF, 
                         0x81, 0xBF, 0x81, 0xFF,       //
                         0x81, 0xAF, 0x8F, 0xFF,       //
				         0x81, 0xF7, 0xEF, 0x81, 0xFF, //
				         0x81, 0xAD, 0x8D, 0xE1, 0xFF, //
				         0x81, 0xAD, 0xBD, 0xFF,       //				   
				         0xBF, 0x81, 0xBF,             //
				         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF,
                         0xFF, 0xFF, 0xFF};
char ukaz=0;				   
unsigned int countStr = 30;
unsigned int countStrTek = 0;
char portb1 = 0;

int Re1, Lm1, Re2;
unsigned char f_fir = 0;
unsigned char firN = 0;
unsigned char ugol1, ugol2;
unsigned char Uadc;
unsigned char Uadc1;
unsigned char Uadc3;
unsigned char Uadc2;
unsigned char Uadc4;
unsigned char Uadc5;
unsigned char Uadc6;
unsigned char Uadc7;
unsigned char Uadc8;
unsigned char Uadc9;
unsigned char Uadc10;
unsigned char Uadc11;
unsigned char Uadc12;
unsigned short result1, result_Volt;
unsigned short i=0, j=0;
unsigned char smech = 0;
unsigned long summ;

unsigned char LOGdft1[10] = {120, 22, 15, 11, 9, 6, 5, 4, 3, 0};
unsigned char linVD[9]=    {0xFF, 0xFE, 0xFC, 0xF8, 0xF0, 0xE0, 0xC0, 0x80, 0x00};  

//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 //  
 DDRA  = 0xFE;
 PORTA = 0x00; 
 DDRB  = 0xFF;
 PORTB = 0x1C; 
 PORTC = 0x00; //m103 output only
 DDRC  = 0xFF;
 DDRD  = 0xFF;
 PORTD = 0x00;//0x40; 
 //   : 52 uS 19.2 
 ADCSR = 0x00; //disable adc
 ADMUX = 0x00; //select adc input 0 //    
 ACSR  = 0x80;
 ADCSR = 0xEE; //0xCD; 

 MCUCR = 0x12; 
 GICR  = 0x00;
 TIMSK = 0x00; //timer interrupt sources
 SEI(); //re-enable interrupts
 //all peripherals are now initialized 
 asm("sleep"); //    ,     
}

//
void main(void)
{
 init_devices();
 //insert your functional code here... 
 while(1)
 {
    while(f_adc==0);   
    //----------------- 
	Uolsh1();	
	Uolsh2();
	Uolsh3();
	Uolsh4(); 
	Uolsh5(); 	   		
	Uolsh6();  
	Uolsh7();	  
	Uolsh8();  //  1,2 	
	Uolsh9();  
	Uolsh10();	
	Uolsh11();		  		
    Uolsh12();
	    
	/*if(countStrTek == countStr)
    {
       ukaz++;
	   if(ukaz == 38)
	      ukaz = 0;
	   countStrTek = 0;
    } 
    else
       countStrTek++;*/
	
	f_adc=0;	
	MCUCR = 0x12;    //        
    asm("sleep");	 //           
  } 
}

#pragma interrupt_handler timer0_ovf_isr:10
void timer0_ovf_isr(void)
{
  TCNT0 = 0xB0; //reload counter value   
}


//     19.2kHz
#pragma interrupt_handler adc_isr:15
void adc_isr(void)
{
 //conversion complete, read value (int) using...
 value  = ADCL>>2;            //Read 8 low bits first (important)
 value |= ADCH<<6;  
 count++;
 if(count==countVD)           // 
 { 
    count = 0;
    VD_select(); 
 }	
 if(f_adc == 0)               //      
 {
    buffer[countBuf] = value;
    countBuf++; 
  
    if(countBuf==countFIR)    //     
    {
       countBuf=0;
	   f_adc=1;	      	 	  //        
    } 
    else
    { 
       MCUCR = 0x12;          //    ,       
       asm("sleep");
    }
 }   
}

void adc_interrupt(void)
{
   if(ADCSR&0x10)
   {
      count++;
      if(count==countVD)           // 
      { 
         count = 0;
		 VD_select(); 
      }	
   }   
}

//---------------------  
void VD_select(void)
{
    N++;
    switch(N)
	{
	   case 1:
	      //PORTB = 0x1C;
		  PORTD = Uadc1;//privet[ukaz];
		  PORTC = Uadc2;//privet[ukaz+1];
		  PORTA = Uadc3&0xFE;//privet[ukaz+2]&0xFE;
		  portb1 = Uadc3&0x01;//privet[ukaz+2]&0x01;
		  PORTB = portb1|0x1C;			  
		  break;	      
	   case 2:
	      //PORTB = 0x1A;
		  PORTD = Uadc4;//privet[ukaz+3];
		  PORTC = Uadc5;//privet[ukaz+4];
		  PORTA = Uadc6&0xFE;//privet[ukaz+5]&0xFE;
		  portb1 = Uadc6&0x01;//privet[ukaz+5]&0x01;
		  PORTB = portb1|0x1A;	
		  break;
	   case 3:
	      //PORTB = 0x16;
		  PORTD = Uadc7;//privet[ukaz+6];
		  PORTC = Uadc8;//privet[ukaz+7];
		  PORTA = Uadc9&0xFE;//privet[ukaz+8]&0xFE;
		  portb1 = Uadc9&0x01;//privet[ukaz+8]&0x01;
		  PORTB = portb1|0x16;		  
		  break;	   
	   case 4:	      
		  PORTD = Uadc10;//privet[ukaz+9];
		  PORTC = Uadc11;//privet[ukaz+10];
		  PORTA = Uadc12&0xFE;//privet[ukaz+11]&0xFE;
		  portb1 = Uadc12&0x01;//privet[ukaz+11]&0x01;
		  PORTB = portb1|0x0E;
		  N = 0;		  
		  break;	    	  	   
	}		   
}

//---------       
unsigned short isqrt(unsigned int from)
 {
   unsigned int mask = 0x4000, sqr = 0, temp;
   do {
        temp = sqr | mask;
        sqr >>= 1;
        if( temp <= from )
        {
            sqr |= mask;
            from -= temp;
        }
     }
     while( mask >>= 2 );
     //     if( sqr < from ) ++sqr;
     return (unsigned short)sqr;
 }


//    9,6  
// , .      ,     
//  90 ,      , .    
//   0-  
void Uolsh12(void)
{
    Re1 = Re2 = i = ugol2 = 0;	   
	ugol1 = 1;	
	i=0;
	do
	{	
	   adc_interrupt();     
	   //  
	   if(i == ugol1)
	      Re1 = Re1 - buffer[i]; 
	   else
	      Re1 = Re1 + buffer[i];
	   if(i == ugol2)
	      Re2 = Re2 - buffer[i]; 
	   else
	      Re2 = Re2 + buffer[i]; 
	   
	   if(i == ugol1)
       {  ugol1 = ugol1 + 2;
	      ugol2 = ugol2 + 2;
	   }	    
	   i++; 	
	}
	while(i < 16);  	
	    
	//  
	//   	
	if(Re1 > Re2)
	   result1 = Re1>>4; //    16 
	else
	   result1 = Re2>>4; //    16      	
	//   20 	
	result_Volt = 9;
    i=0;
	do
	{
	    adc_interrupt();  
	    result_Volt--;
        if(result1 <= LOGdft1[i] && result1 >= LOGdft1[i+1])
           break;
		i++;   
    }
	while(i<9);	
	//        
	Uadc12 = linVD[result_Volt]; 	
} 

//    4,8  
void Uolsh11(void)
{
    Uadc11 = UolshFunc(2, 0, 3, 3, 4, 32, 5);
} 

//    2,4  
void Uolsh10(void)
{
    Uadc10 = UolshFunc(4, 1, 6, 7, 8, 32, 5);
} 
 
//    1,6  
void Uolsh9(void)
{
    Uadc9 = UolshFunc(6, 2, 9, 11, 12, 60, 6);
} 
 
//    1,2  
void Uolsh8(void)
{
    Uadc8 = UolshFunc(8, 3, 12, 15, 16, 64, 6);
} 

//    800  
void Uolsh7(void)
{
   Uadc7 = UolshFunc(12, 5, 18, 23, 24, 240, 8); 
   //Uadc3 = UolshFunc(10, 4, 15, 19, 20);  
} 

//    600  
void Uolsh6(void)
{
    Uadc6 = UolshFunc(16, 7, 24, 31, 32, 256, 8);
} 

//    500  
void Uolsh5(void)
{
    Uadc5 = UolshFunc(18, 8, 27, 35, 36, 252, 8);
}

//    400  
void Uolsh4(void)
{
    Uadc4 = UolshFunc(24, 11, 36, 47, 48, 240, 8);
}

//    300  
void Uolsh3(void)
{
    Uadc3 = UolshFunc(32, 15, 48, 63, 64, 256, 8);
}

//    150  
void Uolsh2(void)
{
    Uadc2 = UolshFunc(64, 31, 96, 127, 128, 512, 9);
} 

//    75  
void Uolsh1(void)
{
    Uadc1 = UolshFunc(128, 63, 192, 255, 256, 512, 9);
} 

//  
//ugol_1 -       1
//ugol_2  ugol_3 -     1
//ugol_4 -           2
//ugol_circle -      
//ugol_count -           ugol_1
//  ugol_count            128 
//del -  .  128   7 64 - 6  . . 2   del
unsigned char UolshFunc(unsigned short ugol_1, unsigned short ugol_2, unsigned short ugol_3, unsigned short ugol_4, 
                        unsigned short ugol_circle, unsigned short ugol_count, unsigned char del)
{
    Re1 = Lm1 = 0;    
	i=0;
	do
	{
	   adc_interrupt();  
	   //  , .   sin      0-180  1  -1
	   if(i<ugol_1)
	      Lm1 = Lm1 + buffer[i];
	   else
	      Lm1 = Lm1 - buffer[i];
	   //  
	   if(i>ugol_2 && i<ugol_3)
	      Re1 = Re1 - buffer[i]; 
	   else
	      Re1 = Re1 + buffer[i];
	   if(i == ugol_4)
       {  
	      ugol_1 = ugol_1 + ugol_circle;
	      ugol_2 = ugol_2 + ugol_circle; 
	      ugol_3 = ugol_3 + ugol_circle;
 	      ugol_4 = ugol_4 + ugol_circle;
	   }
	   i++; 	
	}
	while(i<ugol_count);  	
	    
	//          	
	Re1 = Re1>>del; //    2   del
    Lm1 = Lm1>>del; //    2   del
    summ = Re1*Re1 + Lm1*Lm1;
	//   
	result1 = isqrt(summ);	
	//   20 	
	result_Volt = 9;
    i=0;
	do
	{
	    adc_interrupt();  
	    result_Volt--;
        if(result1 <= LOGdft1[i] && result1 >= LOGdft1[i+1])
           break;
		i++;   
    }
	while(i<9);	
	//        
	Uadc = linVD[result_Volt]; 
	return Uadc;
} 